package eu.mikroskeem.utils.bannerparser.parsers;

import eu.mikroskeem.utils.bannerparser.parsers.needcoolshoes.NeedCoolShoesParser;
import eu.mikroskeem.utils.bannerparser.parsers.planetminecraft.PlanetMinecraftParser;
import org.bukkit.block.banner.Pattern;

import java.net.URL;
import java.util.ArrayList;

public class Parsers {
    public static Parser getParser(URL url){
        String host = url.getHost();
        if(host.contains("planetminecraft.com")){
            return new PlanetMinecraftParser();
        } else if (host.contains("needcoolshoes.com")){
            return new NeedCoolShoesParser();
        }
        return null;
    }

    public static ArrayList<Pattern> parse(URL url){
        Parser parser = getParser(url);
        if(parser != null){
            return parser.fromUrl(url);
        } else {
            return null;
        }
    }
}
