package eu.mikroskeem.utils.bannerparser.parsers.planetminecraft;

import eu.mikroskeem.utils.bannerparser.IntegerFromString;
import org.bukkit.DyeColor;
import static org.bukkit.DyeColor.*;

class ColorParser {
    static DyeColor valueOf(String a){
        try {
            /* Test for integer value first */
            String name = IntegerFromString.valueOf(Integer.valueOf(a));
            return ColorEnum.valueOf(name).getColor();
        } catch (NumberFormatException e){
            /* Return by string identifier */
            return ColorEnum.valueOf(a).getColor();
        }
    }

    @SuppressWarnings("unused")
    private enum ColorEnum {
        g(WHITE),
        EIGHT(SILVER),
        NINE(GRAY),
        ONE(BLACK),
        c(YELLOW),
        f(ORANGE),
        TWO(RED),
        FOUR(BROWN),
        b(LIME),
        THREE(GREEN),
        d(LIGHT_BLUE),
        SEVEN(CYAN),
        FIVE(BLUE),
        a(PINK),
        e(MAGENTA),
        SIX(PURPLE);

        private DyeColor color;
        ColorEnum(DyeColor color) {
            this.color = color;
        }
        public DyeColor getColor() {
            return color;
        }
    }
}