package eu.mikroskeem.utils.paste;


import eu.mikroskeem.utils.paste.providers.Hastebin;

import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;

/**
 *
 * @author Mark
 */
public class Paste {
    private final IPaste pasteProvider;
    public Paste(){
        /* Currently only supported provider */
        this.pasteProvider = new Hastebin();
    }

    /**
     * Format exception into proper string
     *
     * @param e Exception to format
     * @return Exception as string
     */
    public static String formatException(Exception e) {
        StringWriter sw = new StringWriter();
        PrintWriter pw = new PrintWriter(sw);
        e.printStackTrace(pw);
        return sw.toString();
    }

    /**
     * Paste stacktrace to pastebin
     *
     * @param e Exception to paste
     * @return Paste url
     */
    public String pasteException(Exception e) throws IOException {
        return pasteProvider.paste(formatException(e));
    }
}
