package eu.mikroskeem.utils.test.text;

import eu.mikroskeem.utils.text.MinecraftText;
import org.junit.Assert;
import org.junit.Test;

public class TestMinecraftUtils {
    @Test public void testValidUsername(){
        Assert.assertTrue(MinecraftText.validateUsername("mikroskeem"));
        Assert.assertTrue(MinecraftText.validateUsername("abcd"));
        Assert.assertTrue(MinecraftText.validateUsername("abc_"));
    }

    @Test public void testInvalidUsername(){
        Assert.assertFalse(MinecraftText.validateUsername("mikros--"));
        Assert.assertFalse(MinecraftText.validateUsername("mikr_os--"));
        Assert.assertFalse(MinecraftText.validateUsername("aa"));
        Assert.assertFalse(MinecraftText.validateUsername("     "));
        Assert.assertFalse(MinecraftText.validateUsername("     "));
    }

    @Test public void testColorReplacing(){
        Assert.assertEquals("§c§lHello", MinecraftText.translateAltColors('&', "&c&lHello"));
    }
}
